package org.greenstone.gsdl3.gs3build.schema;

import org.w3c.dom.Element;

public class SchemaAttribute
{ 
	public final static String ATTRIBUTE_TYPE_STRING = "String";

  String name;
  String type;
  boolean required;

	public SchemaAttribute(Element element) throws SchemaException
	{
		// get the name - things are totally unworkable if it doesn't exist!
		this.name = element.getAttribute("name");
		if (this.name == null) {
			throw new SchemaException("All attributes must have names");
		}

		// ids are quite important in some metadata schema - copy that too
		String id = element.getAttribute("id");

		// get the required field - we don't actually cope with "prohibited" at the moment!
		String use = element.getAttribute("use");
		this.required = (use != null && use.equals("required"));

		// and the type - we don't reflect any further upon this, actually
		this.type = element.getAttribute("type");
		if (this.type == null) {
			this.type = SchemaAttribute.ATTRIBUTE_TYPE_STRING;
		}

		// Constraints should now be added, but at present that is not done, as we
		// are non-validating!
	}
}
